<?php
/*
 * v2, incrementa a partir de la linea 45 un mensaje para revision de spam folder.
 * Se debe crear traducciones en waolicensemanager 
*/
defined( 'ABSPATH' ) or die; 

/// Instanciar clase pestaña en producto (cliente)
function waolm_pestanias_init() {
	if ( is_admin() ) {
		$WAOLM_Pestania = new WAOLM_Pestania();
		$WAOLM_Pestania->init();
	}
}

function inserta_llave_en_thankyoupage($order_id){
        $table_keys = get_post_meta($order_id,'_table_keys',true);
		if($table_keys<>""){
			$template = '
				<style>
				h2 {font-size:25px;}
				.tabla{width:100%;}
				.pname, .pversion {display:inline-block;padding-left:5px;}
				.pversion{text-decoration:underline;}
				.plink{height:40px;}
				.par{background-color:Gainsboro;height:25px;}
				.impar{background-color:white;height:25px;}
				.tablekeys thead tr{background-color:Gray;color:white;height:5px;}
				tr.plink td p{height:15px;}
				tr.impar td p{height:10px;margin-top:0px;margin-bottom:0px;}
				tr.par td p{height:10px;margin-top:0px;margin-bottom:0px;}
				.alert-message {display: flex;align-items: center;background-color:#EEEEEE;border:solid 1px gray;border-radius:5px;padding:10px}
				.exclamation-mark {font-size: 50px;color: #FF0000;margin-right: 30px;}
				.message-content {color:#D04848;font-size:18px;/* Estilos para tu mensaje */}
				</style>
				<div class="tabla">{tabla}</div>
				';
			$tabla = html_entity_decode($table_keys);
			$template1 = '
				<div class="alert alert-warning alert-white rounded">
					<div class="icon"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M569.5 440C588 472 564.8 512 527.9 512H48.1c-36.9 0-60-40.1-41.6-72L246.4 24c18.5-32 64.7-32 83.2 0l239.9 416zM288 354c-25.4 0-46 20.6-46 46s20.6 46 46 46 46-20.6 46-46-20.6-46-46-46zm-43.7-165.3l7.4 136c.3 6.4 5.6 11.3 12 11.3h48.5c6.4 0 11.6-5 12-11.3l7.4-136c.4-6.9-5.1-12.7-12-12.7h-63.4c-6.9 0-12.4 5.8-12 12.7z"/></svg></div>
					<div class="message-content2">{mensaje}</div>
				</div>
 			';	
			$mensaje = __('You will receive this keys in your inbox email too. If not, please see your <b>spam folder</b>','waolicensemanager');
			$template1 = str_replace("{mensaje}",$mensaje,$template1);
			$template = str_replace("{tabla}",$tabla,$template);
			$salida = str_replace("<br><hr>",$template1,$template);
		}else{
			$template = '
				<style>
				
				</style>
			<div class="alert alert-warning alert-white rounded">
			  <div class="icon"><svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><!--!Font Awesome Free 6.5.2 by @fontawesome - https://fontawesome.com License - https://fontawesome.com/license/free Copyright 2024 Fonticons, Inc.--><path d="M569.5 440C588 472 564.8 512 527.9 512H48.1c-36.9 0-60-40.1-41.6-72L246.4 24c18.5-32 64.7-32 83.2 0l239.9 416zM288 354c-25.4 0-46 20.6-46 46s20.6 46 46 46 46-20.6 46-46-20.6-46-46-46zm-43.7-165.3l7.4 136c.3 6.4 5.6 11.3 12 11.3h48.5c6.4 0 11.6-5 12-11.3l7.4-136c.4-6.9-5.1-12.7-12-12.7h-63.4c-6.9 0-12.4 5.8-12 12.7z"/></svg></div>
			  <div class="message-content2">{mensaje}</div>
			</div>
			';
			$mensaje = __('In a few minutes you will receive your order, if it does not appear in your inbox, please check your SPAM folder.','waolicensemanager');
			$salida = str_replace("{mensaje}",$mensaje,$template);
		}
		echo $salida;
}

//add_action( 'woocommerce_before_thankyou', 'inserta_llave_en_thankyoupage' );
//echo $order->get_payment_method()." xxxxxxxx"; //insertar esto en plugins/woocommerce/templates/checkout/thankyou.php linea 81
$waolmoptions = get_option( '_waolm_options' );
if (isset($waolmoptions['payments']) || empty($waolmoptions['payments'])) {
	$payments = explode('|', $waolmoptions['payments']);
	foreach ($payments as $payment_method) {
		add_action('woocommerce_thankyou_' . $payment_method, 'inserta_llave_en_thankyoupage', 30);
	}
}

/*
 * En modo cliente, 2 casos:
 * Siendo tambien servidor: No incluir nada
 * Siendo solo cliente: Crear pagina y subpágina
*/

if(!soy_waolm_servidor()){
	add_action( 'admin_menu', 'menu_cliente');
}
function menu_cliente(){
//                        title		             menutit	     capacidad	        slug			funcion				logo 	           pos
	add_menu_page('WAOLM License Manager', 'WAOLM Client Setting', 'manage_options','waolm_config','wao_settings_page','dashicons-products', 15);//funcion común en waolicensemanager.php
//                    parent_slug         page_title            menu_title       capability   			menu_slug                     callback              position 
	//add_submenu_page( 'waolm_config', 'Configurar cliente', 'Configurar cliente', 'manage_options', 'waolm_subpage_content', 'waolm_subpage_content',20);
//                        title		             menutit	     capacidad	        slug			funcion				logo 	           pos
}

//FUNCIONES DE CLIENTE PAIS CON SERVIDOR ASIGNADO EN MISMO DOMAIN
function return_local_server_keys($sku){
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
		$args = array(
				'numberposts'	=> -1,
				'meta_key'		=> '_waolm_sku',
				'meta_value'	=> $sku,
				'post_type'		=> 'licensemanagerwao',
				'status'		=> 'publish',
				'orderby'		=> 'menu_order',
				'order'			=> 'ASC',
			);

	$lasllaves=get_posts($args);
	$retorno=array();
	$i=0;
	//$fila=array();
	foreach ($lasllaves as $llave){
		$fila[$i] = new stdClass();
		$fila[$i]->id = $llave->ID;
		$fila[$i]->clave = $llave->post_title;
		$fila[$i]->product = get_post_meta($llave->ID,'_product_name',true);
		$fila[$i]->activations = get_post_meta($llave->ID,'_activations',true);
		$fila[$i]->dispatched = get_post_meta($llave->ID,'_dispatched',true);
		$fila[$i]->status = $llave->post_status=='publish'?'Active':'Inactive';
		//$fila[$i]->priority = get_post_meta($llave->ID,'_priority',true);
		$fila[$i]->priority = $llave->menu_order;
		$retorno[]=$fila[$i++];
	}
	if(is_multisite()){
		restore_current_blog();
	}
	return json_encode($retorno);
}

function return_local_products_combo(){
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
		$args = array(
				'numberposts'	=> -1,
				'post_type'		=> 'product',
				'status'		=> 'publish',
				'orderby'		=> 'menu_order',
				'order'			=> 'ASC',
			);
	$productos=get_posts($args);

	global $wpdb;
	//$q="SELECT ID, post_title FROM {$wpdb->prefix}posts WHERE `post_type` = 'product' AND `post_status` = 'publish'";
	$q="SELECT ID, post_title 
		FROM {$wpdb->prefix}posts
		WHERE post_type = 'product'
		   AND post_status = 'publish'
		   AND ID IN (
			SELECT M.meta_value
				FROM {$wpdb->prefix}posts P, {$wpdb->prefix}postmeta M
				WHERE P.post_type = 'licensemanagerwao'
				  AND P.post_status = 'publish'
				  AND P.ID = M.post_id
				  AND M.meta_key = '_product'
			);";
	$resultados=$wpdb->get_results($q);
	$retorno=array();
	$i=0;
	foreach ($resultados as $res){
		$fila[$i] = new stdClass();
		$fila[$i]->sku = get_post_meta($res->ID,'_sku',true);
		$fila[$i]->post_title = $res->post_title;
		$retorno[]=$fila[$i++];
	}
	if(is_multisite()){
		restore_current_blog();
	}
// Usar usort para ordenar el array
	usort($retorno, 'compararPorNombre');

	return json_encode($retorno);
	//preparar respuesta json
	//insertar la respuesta en una page con shortcode
}

// Función de comparación para ordenar por post_title
function compararPorNombre($a, $b) {
    return strcmp($a->post_title, $b->post_title);
}

function cuantas_llaves_server_local($product_sku,$variation){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	$q="SELECT COUNT(meta_value)
		FROM {$wpdb->prefix}postmeta
		WHERE meta_key = '_activations'
		  AND meta_value >= {$variation}
		  AND post_id IN (
			SELECT post_id
				FROM {$wpdb->prefix}postmeta
				WHERE meta_key = '_waolm_sku'
				  AND meta_value = '{$product_sku}')"; 
	  
	$var=$wpdb->get_var($q);
	if(is_multisite()){
		restore_current_blog();
	}
	//update_blog_option(1,'_depu',$q);
	return $var[0];
	//return $var[0]>0?$var[0]:1; 
}

function lasllaves_server_local($product_sku,$variation,$quantity,$priority){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	$margen=5;
	$q="SET @numero=0";//@numero:=@numero+1 AS nro,
	$s = $wpdb->get_var($q);	  
	$q="
	SELECT  P.menu_order AS nro, P.ID AS keyid, P.post_title AS skey, Q.meta_value AS productname, P.menu_order AS priority, M.meta_value AS product_sku
		FROM {$wpdb->prefix}posts P 
		LEFT JOIN {$wpdb->prefix}postmeta M ON P.ID = M.post_id AND M.meta_key = '_waolm_sku' 
		LEFT JOIN {$wpdb->prefix}postmeta N ON P.ID = N.post_id AND N.meta_key = '_activations'
		LEFT JOIN {$wpdb->prefix}postmeta Q ON P.ID = Q.post_id AND Q.meta_key = '_product_name'
		WHERE P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_value = '{$product_sku}'
		  AND N.meta_value >= {$variation}
		  AND P.menu_order >= {$priority}
		ORDER BY priority ASC
		LIMIT {$quantity}";  
	$r = $wpdb->get_results($q);	  
	if(is_multisite()){
		restore_current_blog();
	}
	return json_encode($r);
}//function END
function activaciones_server_local($skey,$product_sku,$variation,$nro){ // consulta sobre cpt licenses en servidor. Requiere switch_to_blog
	$retorno=1;
	if(is_multisite()){
		switch_to_blog(get_waolm_server_id());
	}
	global $wpdb;
	//necesitamos obtener el id a partir del sku recibido.
	//$args = array('numberposts'=>1,'post_title'=>$skey,'post_type'=>'licensemanagerwao', 'post_status'=>'publish','meta_key'=>'_waolm_sku','meta_value'=>$product_sku,'meta_compare'=>'=');
	$tp=$wpdb->prefix;	
	$q="SELECT P.ID
		FROM ".$tp."posts P, ".$tp."postmeta M
		WHERE P.ID = M.post_id
		  AND P.post_title = '".$skey."'
		  AND P.post_type = 'licensemanagerwao'
		  AND P.post_status = 'publish'
		  AND M.meta_key = '_waolm_sku'
		  AND M.meta_value = '".$product_sku."'";
	$waolmkey_id=$wpdb->get_var($q);
	//$waolmkey=get_posts($args); $waolmkey_id=$waolmkey[0]->ID;
	$nuevo = get_post_meta($waolmkey_id, '_activations');
	$nuevo = (int)$nuevo[0] - $variation;
	if(!update_post_meta($waolmkey_id, '_activations',$nuevo)){$retorno=0;}

	$nuevo = get_post_meta($waolmkey_id, '_dispatched');
	$nuevo = (int)$nuevo[0] + $variation;
	if(!update_post_meta($waolmkey_id, '_dispatched',$nuevo)){$retorno=0;}
	if(is_multisite()){
		restore_current_blog();
	}
	return $retorno;
}//function actualiza END

function agregar_contenido_footer_correosborrar($email) {
	if(isset($email)){
		$order_id = $email->object->get_id();
		//$order_id = 56074;
		//echo '<hr>';
		echo '<div style="background-color:#F5F5F5;border-left:solid 2px gray;margin-left:10px;margin-right:10px;padding:10px;text-decoration:none;">';
		echo '<p>'.__('The company guarantees the functionality of the product you received.','wao-tiendas').'</p>';
		echo '<p>'.__('If you have problems with it, our customer service department will solve any problem until you are completely satisfied.','wao-tiendas').'</p>';
		echo '<p>'.__('Contact us through:','wao-tiendas').'</p>';
		$su=get_option('home')."/support?order_id=".$order_id;
		echo '<a href="'.$su.'"><span style="background-color:#6527BE;border:solid 1px green;color:white;border-radius:10px;padding:5px 20px 5px 20px;"><i class="fa fa-comment-o" aria-hidden="true">&nbsp;'.__('Support','wao-tiendas').'</i></span></a></div>';
	}
}

// Aniadir contenido adicional al correo de completed order.
function cont_adi_customer_email($order, $sent_to_admin, $plain_text, $email){
	if ($email->id === 'customer_completed_order') {
		$template = '<div style="background-color:#F5F5F5;border-left:solid 2px gray;margin-left:10px;margin-right:10px;padding:10px;text-decoration:none;margin-bottom:8px;">{parrafos}</div>';
		
		$p[] = __('If you have a pre-installed Office version do this:','waolicensemanager');
		$p[] = __('To do a successful Office removal, we suggest you use the official Microsoft Tool to uninstall Office.','waolicensemanager');
		$p[] = __('Here you have the link for the Microsoft Office Removal Tool: ','waolicensemanager');
		$p[] = 'https://aka.ms/diag_officeuninstall';
		$p[] = __('After completely uninstalling using the tool, please reinstall your product from our link.','waolicensemanager');
		$link = get_option("home")."/faq";
		$link = '<a href="'.$link.'">'.__('Here','waolicensemanager').'</a>';
		$p[] = str_replace("{linkfaq}",$link,__('If you have more questions please visit our FAQ page: {linkfaq}','waolicensemanager'));
		//echo $texto;
		$lineas = "";
		foreach ($p as $p1){
			$lineas.= '<p style="pemail">'.$p1.'</p>';
		}
		echo str_replace("{parrafos}",$lineas,$template);
	}
}
add_action( 'woocommerce_email_order_details', 'cont_adi_customer_email', 6, 5 );

// Creamos nuevo template para los detalles de la orden en el correo, PARA ALINEAR SUBTOTAL A LA DERECHA
function waolicensemanager_locate_template($template, $template_name, $template_path) {
    global $woocommerce;
    $_template = $template;
    if (!$template_path) $template_path = $woocommerce->template_url;
    $plugin_path  = waolicensemanager_plugin_path() . '/templates/';
    // Verifica si el template solicitado es email-order-details.php
    if (strpos($template, 'email-order-details.php') !== false) {
        $template = $plugin_path . 'emails/email-order-details.php'; 
    }
    // Devuelve el archivo de template de tu plugin si existe
    if (file_exists($template)) {
        return $template;
    }
    // De lo contrario, devuelve el template por defecto de WooCommerce
    return $_template;
}
add_filter('woocommerce_locate_template', 'waolicensemanager_locate_template', 10, 3);

function waolicensemanager_plugin_path() {
    // Cambia la ruta al directorio de tu plugin
    return untrailingslashit(plugin_dir_path(__FILE__));
}

	
